unit janReplace;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TPosChar= set of char;
  
  TjanReplace = class(TComponent)
  private
    function NextPos(Substr, s: string; from: integer;
      caseSensitive: boolean): integer;
    function NextPosChar(Substr, s: string; from: integer;
      caseSensitive: boolean; PoSet: TPosChar): integer;
    function NextPosTerm(Substr, s, Term: string; TermIndex, from: integer;
      caseSensitive: boolean; poSet: TPosChar): integer;
    function SmartFind(s: string; from: integer; AFind: string;
      CaseSensitive: boolean): integer;
    function SmartReplace(var s: string; from: integer; AFind,
      AReplace: string; CaseSensitive: boolean): integer;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function Find(Atext, FindText: string; from: integer;   CaseSensitive: boolean; var SelStart, SelEnd: integer): boolean;
    function Replace(aText,Findtext,ReplaceText: string;All,CaseSensitive:boolean): string;
  published
    { Published declarations }
  end;

procedure Register;

implementation

const
  cr = chr(13)+chr(10);
  tab = chr(9);

var
  StartPos, EndPos:integer;
  FirstPos: integer;
  TermGroup: array [0..31] of string;

procedure Register;
begin
  RegisterComponents('Jans 2', [TjanReplace]);
end;

{ TjanReplace }

function TjanReplace.Replace(aText,Findtext,ReplaceText: string;All,CaseSensitive:boolean): string;
var
  s,ftex,rtex:string;
  from:integer;
begin
  ftex:=findText;
  ftex:=stringreplace(ftex,'~~',cr,[rfreplaceall]);
  rtex:=replaceText;
  rtex:=stringreplace(rtex,'~~',cr,[rfreplaceall]);
  result:=AText;
  // wildcards not allowed at begin or end
  if ftex='' then exit;
  if (ftex[1]='*') or (ftex[length(ftex)]='*') then
  begin
    showmessage('"*" not allowed at beginning or end of');
    exit;
  end;
  if rtex<>'' then
    if (rtex[1]='*') or (rtex[length(rtex)]='*') then
    begin
      showmessage('"*" not allowed at beginning or end of');
      exit;
    end;

  //  Result:=stringreplace(AText,ftex,rtex,[rfreplaceall]);
  s:=Atext;
  from:=1;
  if not all  then
  begin
    SmartReplace(s,from,ftex,rtex,CaseSensitive);
    result:=s;
  end
  else
  begin
    from:=SmartReplace(s,from,ftex,rtex,CaseSensitive);
    while from<>0 do
      from:=SmartReplace(s,from,ftex,rtex,CaseSensitive);
    result:=s;
  end;
end;

function TjanReplace.SmartReplace(var s:string;from:integer;AFind,AReplace:string; CaseSensitive:boolean):integer;
const
    crChar=chr(13);
    lfChar=chr(10);
    tabChar=chr(9);

var sf,sr,ws,atom,Substr,term:string;
    L,p,i,atomindex:integer;
    poSet:TPosChar;
    poChar:char;

begin
  result:=SmartFind(s,from,Afind,CaseSensitive);
  if result=0 then exit;
  // now start replacement
  if AReplace='' then
  begin
    delete(s,StartPos,EndPos-StartPos+1);
    result:=StartPos-1;
    if result>length(s) then result:=0;
    exit;
  end;
  sr:='';  // initialize compound replacestring
  while AReplace<>'' do
  begin
    p:=pos('[',AReplace);
    if p=0 then  // simple replace
    begin
      sr:=sr+AReplace;
      AReplace:='';
    end
    else if p>1 then
    begin
      substr:=copy(AReplace,1,p-1);
      Delete(AReplace,1,p-1);
      sr:=sr+SubStr;
    end
    else if p=1 then
    begin  // termgroup
      p:=pos(']',AReplace);
      if p=0 then exit;
      atom:=copy(AReplace,2,p-2);
      delete(AReplace,1,p);
      p:=pos(':',atom);  //index terminal
      if p=0 then exit;
      try
        atomindex:=strtoint(copy(atom,1,p-1));
        if (atomindex<0) or (atomindex>31) then exit;
        except
          exit;
        end;
      delete(atom,1,p);
      substr:=atom;
      if TermGroup[atomindex]='' then exit;
      substr:=stringreplace(TermGroup[atomindex],'||',substr,[rfreplaceall]);
      sr:=sr+substr;
    end;
  end;
  delete(s,StartPos,EndPos-StartPos+1);
  insert(sr,s,StartPos);
  result:=StartPos+length(sr)-1;
  if result>length(s) then result:=0;
end;

function TjanReplace.SmartFind(s:string;from:integer;AFind:string; CaseSensitive:boolean):integer;
const
    crChar=chr(13);
    lfChar=chr(10);
    tabChar=chr(9);

var sf,sr,ws,atom,Substr,term:string;
    L,p,i,atomindex:integer;
    poSet:TPosChar;
    poChar:char;
    OldFind:string;
begin
  // wildcard * and grouping [*</TD>] allowed
  result:=0;
  poSet:=[];
  OldFind:=AFind;
  if Afind='' then exit;
  StartPos:=0;
  EndPos:=from;
  while AFind<>'' do
  begin
    p:=pos('[',Afind);
    if p=0 then  // simple find
    begin
      substr:=Afind;
      Afind:='';
      p:=nextpos(Substr,s,from,CaseSensitive);
      if p=0 then exit;
      EndPos:=p+Length(Substr)-1;
      if StartPos=0 then
      begin
        StartPos:=p;
        FirstPos:=EndPos;
      end;
      from:=EndPos;
    end
    else if p>1 then
    begin
      substr:=copy(Afind,1,p-1);
      Delete(Afind,1,p-1);
      p:=nextpos(Substr,s,from,CaseSensitive);
      if p=0 then exit;
      EndPos:=p+Length(Substr)-1;
      if StartPos=0 then
      begin
        StartPos:=p;
        FirstPos:=EndPos;
      end;
      from:=EndPos;
    end
    else if p=1 then
    begin  // termgroup
      p:=pos(']',Afind);
      if p=0 then exit;
      atom:=copy(Afind,2,p-2);
      delete(Afind,1,p);
      poChar:=atom[1];
      if not (pochar in ['*','a','A','n','N','s','S','t','T','c','C','w','W']) then exit;
      case poChar of
      '*':poSet:=[]; // all
      'a','A':poSet:=['a'..'z','A'..'Z'];
      's','S':poSet:=[' ']; // space
      'n','N':poSet:=['0'..'9']; // numerals
      'c','C':poSet:=[crChar,lfChar]; // carriage return and linefeeds
      'w','W':poSet:=[' ',tabChar,crChar,lfChar]; // whitespace
      't','T':poSet:=['a'..'z','A'..'Z','1'..'6','<','>','/']; //tag
      end;
      delete(atom,1,1);
      p:=pos(':',atom);  //index terminal
      if p=0 then exit;
      try
        atomindex:=strtoint(copy(atom,1,p-1));
        if (atomindex<0) or (atomindex>31) then exit;
        except
          exit;
        end;
      delete(atom,1,p);
      p:=pos('|',atom);
      if p>0 then
      begin
        substr:=copy(atom,1,p-1);
        term:=copy(atom,p+1,length(atom));
      end
      else
      begin
        substr:=atom;
        term:='';
      end;
      if substr='' then exit;
      p:=nextPosTerm(substr,s,Term,atomindex,from,CaseSensitive,poSet);
      if p=0 then
      begin
        if FirstPos<length(s) then
          result:=SmartFind(s,FirstPos,OldFind,CaseSensitive);
        exit;
      end;
      if StartPos=0 then
      begin
        StartPos:=from;
      end;
      EndPos:=p;
      from:=EndPos;
    end;
  end;
  result:=StartPos;
end;


function TjanReplace.NextPos(Substr,s:string;from:integer;caseSensitive:boolean):integer;
var p:integer;
    s0:string;
begin
  s0:=copy(s,from+1,length(s));
  if CaseSensitive then
   p:=pos(Substr,s0)
  else
   p:=pos(uppercase(SubStr),uppercase(s0));
  if p=0 then
    result:=0
  else
    result:=from+p;
end;

function TjanReplace.NextPosChar(Substr,s:string;from:integer;caseSensitive:boolean;PoSet:TPosChar):integer;
var p,i:integer;
    s0:string;
begin
  s0:=copy(s,from+1,length(s));
  if CaseSensitive then
   p:=pos(Substr,s0)
  else
   p:=pos(uppercase(SubStr),uppercase(s0));
  if p=0 then
  begin
    result:=0;
    exit;
  end
  else
    result:=from+p;
  if PoSet=[] then exit;
  for i:=from+1 to Result-1 do
    if not (s[i] in PoSet) then
    begin
      result:=0;
      exit;
    end;
end;

// finds termgroups limited by 'term' e.g [*0:</TR>|</TABLE>]
// if 'term' is empty the pattern will be found once e.g. [0:</TR>]
function TjanReplace.NextPosTerm(Substr,s,Term:string;TermIndex,from:integer;caseSensitive:boolean;poSet:TPosChar):integer;
var p,pterm,L:integer;
begin
  result:=0;
  L:=length(Substr);
  TermGroup[TermIndex]:='';
  if Term<>'' then
  begin
    pterm:=NextPos(Term,s,from,CaseSensitive);
    if pterm=0 then exit;
  end;
  repeat
    p:=NextPosChar(Substr,s,from,CaseSensitive,poSet);
    if p=0 then
    begin
      if TermGroup[TermIndex]='' then exit;
      result:=from;
      exit;
    end;
    if term='' then
    begin
      Termgroup[TermIndex]:=Termgroup[TermIndex]+
           copy(s,from+1,p-(from+1))+'||';
      from:=p+L-1;
    end
    else if p<pterm then
    begin
      Termgroup[TermIndex]:=Termgroup[TermIndex]+
         copy(s,from+1,p-(from+1))+'||';
      from:=p+L-1;
    end;
  until (Term='') or (p>=pterm);
  if TermGroup[TermIndex]='' then exit;
  result:=from;
end;

function TjanReplace.Find(Atext,FindText:string; from:integer;CaseSensitive:boolean; var SelStart, SelEnd:integer):boolean;
var
  s,Afind:string;
  p:integer;
begin
  Afind:=FindText ;
  s:=AText;
  p:=SmartFind(s,from,Afind,CaseSensitive);
  result:=p<>0;
  if p<>0 then
  begin
    SelStart:=Startpos;
    SelEnd:=EndPos+1;
  end;
end;


end.
